<?php
/**
 * @In the name of God!
 * @author: Hamid Rezazadeh
 * @email: hamidrezazadeh@live.com
 * @link: http://www.apadanacms.ir
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright © 2012-2013 ApadanaCms.ir. All rights reserved.
 * @Apadana CMS is a Free Software
 */

defined('security') or exit('Direct Access to this location is not allowed.');

function module_etelaie_info()
{
	return array(
		'name' => 'etelaie',
		'version' => '1.0',
		'creationDate' => '2012-07-21 18:00:03',
		'description' => 'ماژول اطلاعیه ها.',
		'author' => 'Hamid Rezazadeh',
		'authorEmail' => 'hamidrezazadeh@live.com',
		'authorUrl' => 'http://www.apadanacms.ir',
		'license' => 'GNU/GPL',
	);
}

function module_etelaie_install()
{
	global $d;

	member::check_admin_page_access('modules') or exit('Warning access!');
	$d->query("
		CREATE TABLE `#__etelaie` (
		  `article_id` int(255) NOT NULL AUTO_INCREMENT,
		  `article_title` varchar(300) NOT NULL,
		  `article_slug` varchar(200) NOT NULL,
		  `article_time` int(10) NOT NULL DEFAULT '0',
		  `article_author` int(255) NOT NULL DEFAULT '0',
		  `article_text` longtext NOT NULL,
		  `article_theme` varchar(200) NOT NULL,
		  `article_view` int(1) NOT NULL DEFAULT '1',
		  `article_comment` int(1) NOT NULL DEFAULT '1',
		  `article_comment_count` int(255) NOT NULL DEFAULT '0',
		  `article_approve` int(1) NOT NULL DEFAULT '0',
		  PRIMARY KEY (`article_id`),
		  KEY `article_slug` (`article_slug`)
		) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
	");
	$d->insert('modules', array(
		'module_name' => 'etelaie',
		'module_version' => '1.0',
		'module_status' => 0,
	));
	echo message('ماژول اطلاعیه ها با موفقیت نصب شد.', 'success');
}

function module_etelaie_uninstall()
{
	global $d;

	member::check_admin_page_access('modules') or exit('Warning access!');
	$d->query("DROP TABLE `#__etelaie`");
	$d->delete('comments', "comment_type='etelaie'");
	$d->delete('modules', "module_name='etelaie'", 1);
	$d->delete('admin', "admin_rights='etelaie'", 1);
	echo message('ماژول اطلاعیه ها با موفقیت حذف شد.', 'success');
	remove_cache('module-etelaie', true);
}

function module_etelaie_active()
{
	global $d;

	member::check_admin_page_access('modules') or exit('Warning access!');
	$d->update('modules', array('module_status'=>1), "module_name='etelaie'", 1);

	$d->insert('admin', array(
		'admin_rights' => 'etelaie',
		'admin_image' => 'engine/images/admin/pages.png',
		'admin_title' => 'اطلاعیه ها',
		'admin_link' => '?admin={admin}&amp;module=etelaie',
		'admin_page' => 2,
	));
	echo message('ماژول اطلاعیه ها فعال شد.', 'success');
}

function module_etelaie_inactive()
{
	global $d;

	member::check_admin_page_access('modules') or exit('Warning access!');
	$d->update('modules', array('module_status'=>0), "module_name='etelaie'", 1);
	$d->delete('admin', "admin_rights='etelaie'", 1);
	echo message('ماژول اطلاعیه ها غیرفعال شد.', 'success');
}

function module_etelaie_admin_comments($action, $data = array())
{
	global $d, $options;

	member::check_admin_page_access('comments') or warning('عدم دسترسی!', 'شما دسترسی لازم برای مشاهده این بخش را ندارید!');

	switch ($action)
	{
		case 'name';
		return array(
			'etelaie' => 'اطلاعیه ها'
		);
		break;
		
		case 'url';
		$query = "SELECT `article_slug`, `article_id` FROM `#__etelaie` WHERE `article_approve`='1' AND `article_id`='".intval($data['link'])."' LIMIT 1";	
		$post = $d->get_row($query);
		return url('etelaie/'.($options['rewrite'] == 1? $post[0]['article_slug'] : $post[0]['article_id']));
		break;
		
		case 'approve';
		$total = $d->numRows("SELECT `comment_id` FROM `#__comments` WHERE `comment_type`='etelaie' AND `comment_approve`='1' AND `comment_link`='".intval($data['link'])."'", true);
		$d->query("UPDATE `#__etelaie` SET `article_comment_count`='".intval($total)."' WHERE `article_id`='".intval($data['link'])."' LIMIT 1");
		break;
		
		case 'delete';
		$total = $d->numRows("SELECT `comment_id` FROM `#__comments` WHERE `comment_type`='etelaie' AND `comment_approve`='1' AND `comment_link`='".intval($data['link'])."'", true);
		$d->query("UPDATE `#__etelaie` SET `article_comment_count`='".intval($total)."' WHERE `article_id`='".intval($data['link'])."' LIMIT 1");
		break;
	}
	return false;
}

function module_etelaie_admin()
{
	member::check_admin_page_access('etelaie') or warning('عدم دسترسی!', 'شما دسترسی لازم برای مشاهده این بخش را ندارید!');
	require_once(root_dir.'modules/etelaie/functions.admin.php');

	$_GET['do'] = get_param($_GET, 'do');

	switch($_GET['do'])
	{
		case 'new':
		_new();
		break;

		case 'get-data':
		_get_data();
		break;
		
		case 'edit':
		_edit();
		break;
		
		case 'approve':
		_approve();
		break;

		case 'delete':
		_delete();
		break;
		
		default:
		_index();
		break;
	}
}

?>