<?php
/**
 * @In the name of God!
 * @author: Hamid Rezazadeh
 * @email: hamidrezazadeh@live.com
 * @link: http://www.apadanacms.ir
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright © 2012-2013 ApadanaCms.ir. All rights reserved.
 * @Apadana CMS is a Free Software
 */

defined('security') or exit('Direct Access to this location is not allowed.');

function module_etelaie_run()
{
	global $article, $d, $tpl, $options;
	
	if ($options['rewrite'] == 1)
	{
		$slug = isset($_GET['b'])? urlencode($_GET['b']) : null;
	}
	else
	{
		$slug = isset($_GET['b'])? intval($_GET['b']) : 0;
	}

	if ($slug == '' || ($options['rewrite'] != 1 && is_numeric($slug) && $slug <= 0))
	{
		set_title('اطلاعیه ها');
		set_meta('description', 'اطلاعیه ها سایت', 'add');
		set_canonical(url('etelaie'));
		set_content('لیست اطلاعیه ها', block_etelaie(array(
			'total' => 500,
			'order' => 'rand'
		), 'list'));

		($hook = get_hook('module_etelaie_index'))? eval($hook) : null;
	}
	else
	{
		$d->query("
			SELECT etelaie.*, members.member_name, members.member_alias
			FROM #__etelaie AS etelaie	
			LEFT JOIN #__members AS members ON members.member_id=etelaie.article_author
			WHERE etelaie.article_approve = '1' AND etelaie.article_".($options['rewrite'] == 1? 'slug' : 'id')." = '".$d->escapeString($slug)."'
			GROUP BY etelaie.article_id
			ORDER BY etelaie.article_time DESC, etelaie.article_id DESC
			LIMIT 1
		");
		$row = $d->fetch();

		($hook = get_hook('module_etelaie_start'))? eval($hook) : null;

		if (!isset($row) || !is_array($row) || !count($row))
		{
			module_error_run('404');
		}
		else
		{
			$row['article_theme'] = is_alphabet($row['article_theme'])? $row['article_theme'] : null;

			set_theme($row['article_theme']);
			set_title($row['article_title']);
			set_meta('description', $row['article_title'], 'add');
			set_canonical(url('etelaie/'.($options['rewrite'] == 1? $row['article_slug'] : $row['article_id'])));

			if ($row['article_view'] == 2 && !member) $row['article_text'] = message('فقط کاربران عضو سایت می توانند این اطلاعیه را ببینند!', 'error');
			elseif ($row['article_view'] == 3 && member) $row['article_text'] = message('فقط کاربران مهمان می توانند این اطلاعیه را ببینند!', 'error');
			elseif ($row['article_view'] == 4 && !group_admin) $row['article_text'] = message('فقط مدیران می توانند این اطلاعیه را ببینند!', 'error');
			elseif ($row['article_view'] == 5 && !group_super_admin) $row['article_text'] = message('فقط مدیران کل سایت می توانند این اطلاعیه را ببینند!', 'error');
			$row['article_text'] = replace_links($row['article_text']);
			
			($hook = get_hook('module_etelaie'))? eval($hook) : null;

			if (!file_exists(template_dir.'article.tpl') || !is_readable(template_dir.'article.tpl'))
			{
				set_content($row['article_title'], $row['article_text']);
			}
			else
			{
				$itpl = new template('article.tpl', template_dir);
				$itpl->assign(array(
					'{id}' => $row['article_id'],
					'{url}' => url('etelaie/'.($options['rewrite'] == 1? $row['article_slug'] : $row['article_id'])),
					'{title}' => $row['article_title'],
					'{author}' => empty($row['member_alias'])? $row['member_name'] : $row['member_alias'],
					'{author-profile}' => url('account/profile/'.$row['member_name']),
					'{text}' => $row['article_text'],
					'{theme}' => $row['article_theme']
				));
				$itpl->block('|{date format=[\'"](.+?)[\'"]}|es', 'jdate("\\1", "'.$row['article_time'].'")');

				($hook = get_hook('module_etelaie_tpl'))? eval($hook) : null;

				$tpl->assign('{content}', $itpl->get_var());
				unset($itpl);
			}
			
			if ($row['article_comment'] == 1)
			{
				require_once(engine_dir.'comments.class.php');
				$comments = new comments('etelaie', $row['article_id'], url('etelaie/'.($options['rewrite'] == 1? $row['article_slug'] : $row['article_id'])));
				$comments->build();
			}
		}

		($hook = get_hook('module_etelaie_end'))? eval($hook) : null;
	}
}

function module_etelaie_search($search)
{
	global $d, $options;
	
	$where  = $search['type']==0 || $search['type']==2? " OR p.article_title LIKE '%".$d->escapeString($search['story'])."%'" : null;
	$where .= $search['type']==1 || $search['type']==2? " OR p.article_text LIKE '%".$d->escapeString($search['story'])."%'" : null;
	$where .= !empty($search['author']) && $search['author-full']==0? " OR m.member_name LIKE '%".$d->escapeString($search['author'])."%'" : null;
	$where .= !empty($search['author']) && $search['author-full']==1? " OR m.member_name='".$d->escapeString($search['author'])."'" : null;
	$where  = trim($where, ' OR ');
	
	$query  = "SELECT p.*,m.member_name\n";
	$query .= "FROM #__etelaie AS p\n";
	$query .= "LEFT JOIN #__members AS m ON p.article_author = m.member_id\n";
	$query .= "WHERE p.article_approve='1' AND (".$where.")\n";
	$query .= "GROUP BY p.article_id\n";
	$query .= "ORDER BY p.article_id DESC";

	$query = $d->query($query);
	while($p = $d->fetch($query)) 
	{
		if ($p['article_view']==2 && !member) $p['article_text'] = message('فقط کاربران عضو سایت می توانند این اطلاعیه را ببینند!', 'error');
		elseif ($p['article_view']==3 && member) $p['article_text'] = message('فقط کاربران مهمان می توانند این اطلاعیه را ببینند!', 'error');
		elseif ($p['article_view']==4 && !group_admin) $p['article_text'] = message('فقط مدیران می توانند این اطلاعیه را ببینند!', 'error');
		elseif ($p['article_view']==5 && !group_super_admin) $p['article_text'] = message('فقط مدیران کل سایت می توانند این اطلاعیه را ببینند!', 'error');
	
		$d->insert('search', array(
			'search_key' => $search['key'],
			'search_title' => str_replace($search['story'], '<span style="background:#FFCC33;color:#000000">'.$search['story'].'</span>', $p['article_title']),
			'search_author' => $p['member_name'],
			'search_content' => str_replace($search['story'], '<span style="background:#FFCC33;color:#000000">'.$search['story'].'</span>', nl2br(trim(strip_tags(apadana_substr($p['article_text'], 0, 700).'...')))),
			'search_date' => $p['article_time'],
			'search_module' => 'etelaie',
			'search_url' => url('etelaie/'.($options['rewrite'] == 1? $p['article_slug'] : $p['article_id'])),
			'search_time' => time(),
			'search_keywords' => $search['story']
		));
	}
}

function module_etelaie_sitemap(&$sitemap)
{
	global $d, $options;
	$query = "SELECT * FROM `#__etelaie` WHERE `article_approve` = '1' ORDER BY `article_time` DESC, `article_id` DESC";	
	$etelaie = $d->get_row($query, 'assoc');
	if (is_array($etelaie) && count($etelaie))
	{
		foreach($etelaie as $p)
		{
			$sitemap->addItem(url('etelaie/'.($options['rewrite'] == 1? $p['article_slug'] : $p['article_id'])), $p['article_time'], 'monthly', '0.7');
		}
	}
	unset($etelaie, $query, $p);
}

function module_etelaie_feed(&$feeds)
{
	global $d, $options;
	$query = "SELECT * FROM `#__etelaie` WHERE `article_approve` = '1' ORDER BY `article_time` DESC, `article_id` DESC LIMIT ".intval($options['feed-limit']);	
	$etelaie = $d->get_row($query, 'assoc');
	if (is_array($etelaie) && count($etelaie))
	{
		foreach($etelaie as $p)
		{
			$url = url('etelaie/'.($options['rewrite'] == 1? $p['article_slug'] : $p['article_id']));
			$feeds->addItem(new FeedItem($url, $p['article_title'], $url, $p['article_text'], date3339($p['article_time'])));
		}
	}
	unset($etelaie, $query, $p);
}

function block_etelaie($op = null, $id = null, $position = null)
{
	if ($op=='remove-cache') // admin
	{
		remove_cache('module-etelaie-block-'.$id);
		return true;
	}

	($hook = get_hook('block_etelaie_start'))? eval($hook) : null;

	if (!$rows = get_cache('module-etelaie-block-'.$id))
	{
		$op['total'] = !isset($op['total']) || $op['total']<=0? 10 : intval($op['total']);
		$op['order'] = !isset($op['order'])? 'DESC' : strtoupper($op['order']);
		$op['order'] = $op['order'] != 'DESC' && $op['order'] != 'ASC' && $op['order'] != 'RAND'? 'DESC' : $op['order'];

		global $d;
		$query = "SELECT article_title, article_slug, article_id FROM #__etelaie WHERE article_approve='1' ORDER BY ".($op['order'] == 'RAND'? 'RAND()' : "article_time {$op['order']}, article_id {$op['order']}")." LIMIT {$op['total']}";
		$rows = $d->get_row($query);

		if ($op['order'] != 'RAND')
		{
			set_cache('module-etelaie-block-'.$id, $rows);
		}
	}

	if (is_array($rows) && count($rows))
	{
		global $options;
		
		$html = '<ul id="apadana-block-etelaie">'.n;
		foreach($rows as $row)
		{
			$html .= '<li><a href="'.url('etelaie/'.($options['rewrite'] == 1? $row['article_slug'] : $row['article_id'])).'">'.$row['article_title'].'</a></li>'.n;
		}
		$html .= '</ul>';
	}
	else
	{
		$html = 'هیچ اطلاعیه ای وجود ندارد!';
	}

	($hook = get_hook('block_etelaie_end'))? eval($hook) : null;

	return $html;
}

?>