<?php
/**
 * @In the name of God!
 * @author: Hamid Rezazadeh
 * @email: hamidrezazadeh@live.com
 * @link: http://www.apadanacms.ir
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright © 2012-2013 ApadanaCms.ir. All rights reserved.
 * @Apadana CMS is a Free Software
 */

defined('security') or exit('Direct Access to this location is not allowed.');

member::check_admin_page_access('etelaie') or warning('عدم دسترسی!', 'شما دسترسی لازم برای مشاهده این بخش را ندارید!');

function _index()
{
	global $options, $article, $d, $tpl;
	require_once(engine_dir.'pagination.class.php');
	require_once(engine_dir.'editor.function.php');

	set_title('اطلاعیه ها');

	$order = get_param($_GET, 'order', 'DESC');
	$order = $order=='DESC'? 'DESC' : 'ASC';
	
	$total = get_param($_GET, 'total', 20);
	$total = $total<=0? 20 : $total;

	$_article = get_param($_GET, 'article', 1);
	$_article = $_article<=0? 1 : $_article;

	$total_posts = $d->numRows("SELECT `article_id` FROM `#__etelaie`", true);

	$pagination = new pagination($total_posts, $total, $_article);

	$itpl = new template('modules/etelaie/html/admin/index.tpl');

	$theme = template_info($options['theme']);
	$theme = $theme['pages'];
	$theme = explode(',', $theme);
	$theme2 = array();
	foreach($theme as $t) if (!empty($t) && is_string($t)) $theme2[] = $t;
	if (is_array($theme2) && count($theme2))
	{
		$itpl->add_for('templates', array('{name}' => 'بدون قالب'));
		foreach($theme2 as $t)
		{
			if (!empty($t) && is_string($t))
			{
				$itpl->add_for('templates', array('{name}' => $t));
			}
		}
		$itpl->assign(array(
			'[templates]' => null,
			'[/templates]' => null,
		));
		$itpl->block('#\\[not-templates\\](.*?)\\[/not-templates\\]#s', '');
	}
	else
	{
		$itpl->assign(array(
			'[not-templates]' => null,
			'[/not-templates]' => null,
		));
		$itpl->block('#\\[templates\\](.*?)\\[/templates\\]#s', '');
	}
	unset($theme, $theme2, $t);

	if (is_ajax())
	{
		$d->query("
			SELECT etelaie.*, members.member_name, members.member_alias
			FROM #__etelaie AS etelaie	
			LEFT JOIN #__members AS members ON members.member_id=etelaie.article_author
			GROUP BY etelaie.article_id
			ORDER BY etelaie.article_id {$order}
			LIMIT $pagination->Start, $pagination->End
		");
		if ($d->numRows() >= 1)
		{
			while($data = $d->fetch()) 
			{
				$itpl->add_for('list', array(
					'{odd-even}' => odd_even(),
					'{id}' => $data['article_id'],
					'{article-url}' => url('etelaie/'.($options['rewrite'] == 1? $data['article_slug'] : $data['article_id'])),
					'{title}' => $data['article_title'],
					'{author}' => empty($data['member_alias'])? $data['member_alias'] : $data['member_name'],
					'{past-time}' => get_past_time($data['article_time']),
					'{approve}' => $data['article_approve'],
					'{comment-count}' => $data['article_comment_count'],
					'replace' => array(
						'#\\[approve\\](.*?)\\[/approve\\]#s' => $data['article_approve']==1? '\\1' : '',
						'#\\[not-approve\\](.*?)\\[/not-approve\\]#s' => $data['article_approve']!=1? '\\1' : ''
					)
				));
			}

			$itpl->assign(array(
				'[list]' => null,
				'[/list]' => null,
			));
			$itpl->block('#\\[not-list\\](.*?)\\[/not-list\\]#s', '');
		}
		else
		{
			$itpl->assign(array(
				'[not-list]' => null,
				'[/not-list]' => null,
			));
			$itpl->block('#\\[list\\](.*?)\\[/list\\]#s', '');
		}

		$p = $pagination->build('{article}', true);
		if (is_array($p) && count($p)) 
		{	
			foreach($p as $link) 
			{
				if (!isset($link['article'])) continue;

				$itpl->add_for('etelaie', array(
					'{number}' => $link['number'],
					'replace' => array(
						'#\\[selected\\](.*?)\\[/selected\\]#s' => $link['number']==$_article? '\\1' : '',
					),
				));
			}

			$itpl->assign(array(
				'[etelaie]' => null,
				'[/etelaie]' => null,
			));
		}
		else
		{
			$itpl->block('#\\[etelaie\\](.*?)\\[/etelaie\\]#s', '');
		}
	}

	if ($order == 'DESC')
	{
		$itpl->assign(array(
			'[desc]' => null,
			'[/desc]' => null,
		));
		$itpl->block('#\\[asc\\](.*?)\\[/asc\\]#s', '');
	}
	else
	{
		$itpl->assign(array(
			'[asc]' => null,
			'[/asc]' => null,
		));
		$itpl->block('#\\[desc\\](.*?)\\[/desc\\]#s', '');
	}
	
	$itpl->assign(array(
		'{total}' => $total,
		'{textarea}' => wysiwyg_textarea('etelaie[text]', null),
		'{textarea-edit}' => wysiwyg_textarea('etelaie[text-edit]', null),
	));
	
	if (is_ajax())
	{
		define('no_template', true);
		$itpl->display();
	}
	else
	{
		$tpl->assign('{content}', $itpl->get_var());
	}
}

function _new()
{
	global $d;

	$json = array();
	$json['type'] = 'error';
	$json['message'] = array();

	$etelaie = get_param($_POST, 'etelaie', null, 1);
	$etelaie['title'] = isset($etelaie['title'])? htmlencode($etelaie['title']) : null;
	$etelaie['slug'] = isset($etelaie['slug']) && $etelaie['slug'] != ''? slug($etelaie['slug']) : slug($etelaie['title']);
	$etelaie['text'] = isset($etelaie['text'])? trim($etelaie['text']) : null;
	$etelaie['theme'] = isset($etelaie['theme']) && is_alphabet($etelaie['theme'])? $etelaie['theme'] : null;
	$etelaie['view'] = isset($etelaie['view'])? intval($etelaie['view']) : 1;
	$etelaie['comment'] = isset($etelaie['comment']) && $etelaie['comment'] == 1? 1 : 0;
	$etelaie['approve'] = isset($etelaie['approve']) && $etelaie['approve'] == 1? 1 : 0;
	
	if (empty($etelaie['title']))
	{
		$json['message'][] = 'عنوان اطلاعیه را ننوشته اید!';
	}
	
	if ($etelaie['slug'] == '')
	{
		$json['message'][] = 'نام مستعار اطلاعیه را ننوشته اید!';
	}
	else
	{
		if (apadana_strlen($etelaie['slug']) > 200)
		{
			$json['message'][] = 'نام مستعار بیش از انداره طولانی است!';
		}
		elseif ($d->numRows("SELECT `article_id` FROM `#__etelaie` WHERE `article_slug`='".$d->escapeString($etelaie['slug'])."'", true) >= 1)
		{
			$json['message'][] = 'نام مستعار تکراری است یک نام مستعار دیگر انتخاب کنید!';
		}
	}

	if (empty($etelaie['text']))
	{
		$json['message'][] = 'متن اطلاعیه را ننوشته اید!';
	}
	
	if (count($json['message']))
	{
		$json['message'] = implode('<br/>', $json['message']);
	}
	else
	{
		$etelaie['text'] = template_off($etelaie['text']);
		$etelaie['text'] = template_off($etelaie['text']);
		// $etelaie['text'] = str_replace('[', '&#x5B;', $etelaie['text']);
		// $etelaie['text'] = str_replace('{', '&#x7B;', $etelaie['text']);
	
		$d->insert('etelaie', array(
			'article_title' => $etelaie['title'],
			'article_slug' => $etelaie['slug'],
			'article_text' => $etelaie['text'],
			'article_theme' => $etelaie['theme'],
			'article_view' => $etelaie['view'],
			'article_comment' => $etelaie['comment'],
			'article_approve' => $etelaie['approve'],
			'article_author' => member_id,
			'article_time' => time(),
		));

		if ($d->affectedRows())
		{
			remove_cache('module-etelaie-block', true);
			$json['type'] = 'success';
			$json['message'] = 'اطلاعیه با موفقیت ذخیره شد.';
		}
		else
		{
			$json['message'] = 'در ذخیره اطلاعات خطایی رخ داده مجدد تلاش کنید!';
		}
	}

	$json['slug'] = urldecode($etelaie['slug']);
	exit(json_encode($json));
}

function _get_data()
{
	global $d;
	
	$_GET['id'] = get_param($_GET, 'id', 0);
	$d->query("SELECT * FROM #__etelaie WHERE article_id='".$_GET['id']."' LIMIT 1");

	if ($d->numRows() <= 0)
	{
		exit('{"error":"not found"}');
	}
	
	$row = $d->fetch();

	if ($row['article_author'] != member_id && group_super_admin != 1)
	{
		exit('{"error":"access"}');
	}

	$row['article_slug'] = urldecode($row['article_slug']);
	exit(json_encode($row));
}

function _edit()
{
	global $d;
	
	$_GET['id'] = get_param($_GET, 'id', 0);
	$d->query("SELECT * FROM #__etelaie WHERE article_id='".$_GET['id']."' LIMIT 1");

	if ($d->numRows() <= 0)
	{
		exit('{"type":"error", "message":"این اطلاعیه یافت نشد!"}');
	}
	
	$row = $d->fetch();

	if ($row['article_author'] != member_id && group_super_admin != 1)
	{
		exit('{"type":"error", "message":"شما دسترسی لازم برای ویرایش این اطلاعیه را ندارید!"}');
	}

	$json = array();
	$json['type'] = 'error';
	$json['message'] = array();
	
	$etelaie = get_param($_POST, 'etelaie', null, 1);
	
	if (is_array($etelaie) && count($etelaie))
	{
		$etelaie['title'] = isset($etelaie['title'])? htmlencode($etelaie['title']) : null;
		$etelaie['slug'] = isset($etelaie['slug']) && $etelaie['slug'] != ''? slug($etelaie['slug']) : slug($etelaie['title']);
		$etelaie['text-edit'] = isset($etelaie['text-edit'])? trim($etelaie['text-edit']) : null;
		$etelaie['theme'] = isset($etelaie['theme']) && is_alphabet($etelaie['theme'])? $etelaie['theme'] : null;
		$etelaie['view'] = isset($etelaie['view'])? intval($etelaie['view']) : 1;
		$etelaie['comment'] = isset($etelaie['comment']) && $etelaie['comment'] == 1? 1 : 0;
		$etelaie['approve'] = isset($etelaie['approve']) && $etelaie['approve'] == 1? 1 : 0;
		
		if (empty($etelaie['title']))
		{
			$json['message'][] = 'عنوان اطلاعیه را ننوشته اید!';
		}
		
		if ($etelaie['slug'] == '')
		{
			$json['message'][] = 'نام مستعار اطلاعیه را ننوشته اید!';
		}
		else
		{
			if (apadana_strlen($etelaie['slug']) > 200)
			{
				$json['message'][] = 'نام مستعار بیش از انداره طولانی است!';
			}
			elseif ($row['article_slug'] != $etelaie['slug'] && $d->numRows("SELECT `article_id` FROM `#__etelaie` WHERE `article_slug`='".$d->escapeString($etelaie['slug'])."'", true) >= 1)
			{
				$json['message'][] = 'نام مستعار تکراری است یک نام مستعار دیگر انتخاب کنید!';
			}
		}

		if (empty($etelaie['text-edit']))
		{
			$json['message'][] = 'متن اطلاعیه را ننوشته اید!';
		}
		
		if (count($json['message']))
		{
			$json['message'] = implode('<br/>', $json['message']);
		}
		else
		{
			$etelaie['text-edit'] = template_off($etelaie['text-edit']);
			$etelaie['text-edit'] = template_off($etelaie['text-edit']);
			// $etelaie['text-edit'] = str_replace('[', '&#x5B;', $etelaie['text-edit']);
			// $etelaie['text-edit'] = str_replace('{', '&#x7B;', $etelaie['text-edit']);

			$d->update('etelaie', array(
				'article_title' => $etelaie['title'],
				'article_slug' => $etelaie['slug'],
				'article_text' => $etelaie['text-edit'],
				'article_theme' => $etelaie['theme'],
				'article_view' => $etelaie['view'],
				'article_comment' => $etelaie['comment'],
				'article_approve' => $etelaie['approve'],
			), "article_id='".$_GET['id']."'", 1);
			
			if ($d->affectedRows())
			{
				$json['type'] = 'success';
				$json['message'] = 'اطلاعیه با موفقیت ویرایش شد.';
				remove_cache('module-etelaie-block', true);
			}
			else
			{
				$json['message'] = 'در ذخیره اطلاعات خطایی رخ داده مجدد تلاش کنید!';
			}
		}
	}
	
	$json['slug'] = urldecode($etelaie['slug']);
	exit(json_encode($json));
}

function _approve()
{
	global $d;
	$_GET['id'] = get_param($_GET, 'id', 0);
	
	$d->query("SELECT `article_author`, `article_approve` FROM #__etelaie WHERE article_id='".$_GET['id']."' LIMIT 1");
	$row = $d->fetch();

	if ((!is_array($row) || !count($row)) || ($row['article_author'] != member_id && group_super_admin != 1))
	{
		exit('شما دسترسی لازم برای تغییر وضعیت این اطلاعیه را ندارید!');
	}

	$approve = $row['article_approve'] == 0? 1 : 0;
	
	$d->update('etelaie', array(
		'article_approve' => $approve,
	), "`article_id`='{$_GET['id']}'", 1);

	if ($d->affectedRows())
	{
		remove_cache('module-etelaie-block', true);
		exit($approve == 1? 'active' : 'inactive');
	}
	else
	{
		exit('در ذخیره خطایی رخ داده!');
	}
}

function _delete()
{
	global $d;
	
	$_GET['id'] = get_param($_GET, 'id', 0);
	$d->query("SELECT article_title, article_author FROM #__etelaie WHERE article_id='".$_GET['id']."' LIMIT 1");
	$row = $d->fetch();

	if (!is_array($row) && !count($row))
	{
		redirect(admin_article.'&module=etelaie');
	}
	
	if ($row['article_author'] == member_id || group_super_admin == 1)
	{
		$d->delete('etelaie', "article_id='".$_GET['id']."'", 1);
		remove_cache('module-etelaie-block', true);
		echo message('اطلاعیه <b>'.$row['article_title'].'</b> با موفقیت حذف شد.', 'success');
	}
	else
	{
		echo message('شما دسترسی لازم برای حذف این اطلاعیه را ندارید!', 'error');
	}

	_index();
}

?>